//! @file stk_525.h,v
//!
//! 쌠 (c) 2004 Atmel.
//!
//! 쌠ʒmɂĂlicense.txţقǂ݂B
//!
//! @brief ̧قSTK525p̒ϸۂƒ`܂݂܂B
//!
//! @version 1.14 at90usb128-demo-mouse-1_0_3
//!
//! @todo
//! @bug

#ifndef STK_525_H
#define STK_525_H

//_____ ݸٰ ____________________________________________________________
#include "config.h"

//_____ ϸ ________________________________________________________________

//! @defgroup STK525_module STK525
//! ̕STK525p̒ʰ޳ۑw܂݂܂B
//! @image html stk525.gif
//! @{

	//! @defgroup STK_525_leds LEDǗ
	//! STK525LEDǗ邽߂ϸ
	//! @{
#define Leds_init()			(DDRD |= 0xF0)
#define Leds_on()			(PORTD |= 0xF0)
#define Leds_off()			(PORTD &= 0x0F)
#define Led0_on()			(PORTD |= 0x10)
#define Led1_on()			(PORTD |= 0x20)
#define Led2_on()			(PORTD |= 0x40)
#define Led3_on()			(PORTD |= 0x80)
#define Led0_off()			(PORTD &= 0xEF)
#define Led1_off()			(PORTD &= 0xDF)
#define Led2_off()			(PORTD &= 0xBF)
#define Led3_off()			(PORTD &= 0x7F)
#define Led0_toggle()		(PIND |= 0x10)
#define Led1_toggle()		(PIND |= 0x20)
#define Led2_toggle()		(PIND |= 0x40)
#define Led3_toggle()		(PIND |= 0x80)
#define Leds_set_val(c)		(Leds_off(),PORTD |= (c<<4)&0xF0)
#define Leds_get_val()		(PORTD>>4)
#define Is_led0_on()		(PIND & 0x10 ? TRUE : FALSE)
	//! @}

	//! @defgroup STK_525_joy ޮèǗ
	//! STK525̼ޮèǗ邽߂ϸ
	//! @{
#define Joy_init()			(DDRB &= 0x1F, PORTB |= 0xE0, DDRE &= 0xE7, PORTE |= 0x30)
#define Is_joy_up()			((PINB & 0x80) ?  FALSE : TRUE)
#define Is_joy_not_up()		((PINB & 0x80) ?  TRUE  : FALSE)
#define Is_joy_left()		((PINB & 0x40) ?  FALSE : TRUE)
#define Is_joy_not_left()	((PINB & 0x40) ?  TRUE : FALSE)
#define Is_joy_select()		((PINB & 0x20) ?  FALSE : TRUE)
#define Is_joy_not_select()	((PINB & 0x20) ?  TRUE : FALSE)
#define Is_joy_right()		((PINE & 0x10) ?  FALSE : TRUE)
#define Is_joy_not_right()	((PINE & 0x10) ?  TRUE : FALSE)
#define Is_joy_down()		((PINE & 0x20) ?  FALSE : TRUE)
#define Is_joy_not_down()	((PINE & 0x20) ?  TRUE : FALSE)
	//! @}

	//! @defgroup STK_525_hwb HWBtǗ
	//! HWBtPE2ɐڑAėptƂĂgp邱Ƃł܂B
	//! @{
#define Hwb_button_init()	(DDRE &= 0xFB, PORTE |= 0x04)
#define Is_hwb()			((PINE & 0x04) ?  FALSE : TRUE)
#define Is_not_hwb()		((PINE & 0x04) ?  TRUE : FALSE)
	//! @}

//! STK525 ADCϒRْ`
#define ADC_POT_CH			0x01
#define ADC_MIC_CH			0x02
#define ADC_TEMP_CH			0x00

#ifdef USE_ADC								//!< ̒`config.ḩقŐݒ肳܂B

//! Get_adc_mic_val
//!
//! ̊֐STK525ϲ قA/DϊsU16l10ޯĂ̌ʂԂ܂B
//!
//! @warning USE_ADCconfig.hŒ`ׂłB
//!
//! @param Ȃ
//!
//! @return U16 ϲ̫ݍ̎l
//!
U16 Get_adc_mic_val(void);

//! Get_adc_temp_val
//!
//! ̊֐STK525̉xقA/DϊsU16l10ޯĂ̌ʂԂ܂B
//!
//! @warning USE_ADCconfig.hŒ`ׂłB
//!
//! @param Ȃ
//!
//! @return U16 ۸ފm퉷xl
//!
U16 Get_adc_temp_val(void);

//! Get_adc_pot_val
//!
//! ̊֐STK525̉ϒRقA/DϊsU16l10ޯĂ̌ʂԂ܂B
//!
//! @warning USE_ADCconfig.hŒ`ׂłB
//!
//! @param Ȃ
//!
//! @return U16 ۸މϒRl
//!
U16 Get_adc_pot_val(void);

//! Read_temperature
//!
//! ̊֐STK525̉xقA/DϊsU16l(ł)x10ޯĂ̌ʂԂ܂B
//!
//! @warning USE_ADCconfig.hŒ`ׂłB
//!
//! @param Ȃ
//!
//! @return S16 ł̉xl
//!
S16 Read_temperature(void);

#endif //!USE_ADC

	//! @defgroup STK_525_df_STK525 ATMELʰ޳ DataFlash`Ԑݒ
	//! STK525DataFlashɑ΂Ċ邽߂ϸ
	//! @{
#define DF_4_MB								// STK525ŎDataFlasȟ`

#define DF_SELECT_MEM		0
#define DF_UNSELECT_MEM		1
#define DF_NB_MEM			1

#ifndef AVRGCC
	// PINB0=1,DDB0=0	: SPI]uI݁A/SSް͓͂ٱߒRłB
	// PINB1=1			: SCKM̕͏o͂łB
	// PINB2=1			: SIM̕͏o͂łB
	// PINB3=0			: SOM͓͂̕łB
	// PINB4=1,DDB4=1	: CSHigh쓮ŏo͂łB
	#define Init_df_stk525()		(DDRB_Bit4=1,PORTB_Bit3=1,PORTB_Bit4=1,PORTB_Bit0=1)
	#define DF_CS_PIN				PORTB_Bit4
	#define DF_CS0					DF_CS_PIN
	#define DF_CS1					DF_CS0
	#define DF_CS2					DF_CS0
	#define DF_CS3					DF_CS0
	#define Df_select_df(i, val)	(DF_CS##i = val)
	#define Df_desel_all()			(DF_CS0=DF_UNSELECT_MEM)	// DataFlash؂/CSݒ(High)
#else //! AVRGCCp
	#define Init_df_stk525()		(DDRB |=0x10,PORTB|=0x10,PORTB|=0x01,DDRB &= 0xFE,\
   									 DDRB|=0x01,DDRB|=0x04,DDRB|=0x04)
	#define DF_CS_PORT				PORTB
	#define DF_CS0					4
	#define DF_CS1					DF_CS0
	#define DF_CS2					DF_CS0
	#define DF_CS3					DF_CS0
	#define Df_desel_all()			(DF_CS_PORT|=0x10)	// DataFlash؂/CSݒ(High=I)
#endif
#define df_init_spi()				Init_df_stk525()
	//! @}

//! @}

#endif // STK_525_H
