//!
//! @file usb_device_task.c,v
//!
//! 쌠 (c) 2004 Atmel.
//!
//! 쌠ʒmɂĂlicense.txţقǂ݂B
//!
//! @brief ̧قUSBuǗ܂B
//!
//! USBƂUSBνĂ̐Vv̓𒲂ׂ܂B
//! \ݒ(SETUP)vNƁA̍Ƃusb_standard_request.çقɊ܂܂
//! 邱̍\ݒ̏Jn܂B
//! ̸׽Lv̧قŏ܂B
//!
//! @version 1.5 at90usb128-demo-mouse-1_0_3 $Id: usb_device_task.c,v 1.5 2006/07/27 07:04:41 rletendu Exp $
//!
//! @todo
//! @bug
//!/

//_____ ݸٰ ____________________________________________________________

#include "config.h"
#include "conf_usb.h"
#include "usb_device_task.h"
#include "modules\usb\usb_task.h"

#include "lib_mcu\usb\usb_drv.h"
#include "usb_descriptors.h"
#include "modules\usb\device_chap9\usb_standard_request.h"
#include "lib_mcu\pll\pll_drv.h"

//_____ ϸ ________________________________________________________________

//_____ ` _______________________________________________________________

//!
//! J: (bit) usb_connected
//! usb_connectedVBUSoꂽTRUEɐݒ肳܂B
//! usb_connected͂ȂFALSEɐݒ肳܂B
//!/
bit usb_connected;

//!
//! J: (U8) usb_configuration_nb
//! USBuɂĎgpUSB`Ԑݒ萔i[܂B
//! ̒l0ƈقȂ鎞ɂ͑u`Ԃ(ڑF)ꂽƂӖ܂B
//! USB_DEVICE_FEATURE == ENABLEDłgp܂B
//!/
extern U8 usb_configuration_nb;

//_____ 錾 _______________________________________________________________

//!
//! @brief ̊֐USBuƼъ荞݂܂B
//!
//! ̊֐USBUSB荞݂܂B
//! _͓`ԊǗɓK؂USBۂ𑗂邽߂USBڑoƂłB
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
//!/
void usb_device_task_init (void)
{
	Enable_interrupt();
	Usb_disable();
	Usb_enable();
	Usb_select_device();
#if (USB_LOW_SPEED_DEVICE==ENABLE)
	Usb_low_speed_mode();
#endif
	Usb_enable_vbus_interrupt();
	Enable_interrupt();
}

//!
//! @brief ̊֐USBu܂B
//!
//! ̊֐USBUSB荞݂܂B
//! _͓`ԊǗɓK؂USBۂ𑗂邽߂USBڑoƂłB
//! u@\̊JnVBUSω荞݂܂VBUSHighق̂ǂ炩ɂĈU
//! VBUSڑoƎs܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
void usb_start_device (void)
{
	Pll_start_auto();
	Wait_pll_ready();
	Usb_unfreeze_clock();
	Usb_enable_suspend_interrupt();
	Usb_enable_reset_interrupt();
	usb_init_device();						// USB߲0`Ԑݒ
	Usb_attach();
}

//! @brief USBuǗ̓_
//!
//! ̊֐USBǗ̓_łBeUSBۂ͓K؂ȊJn邽߂ɂ
//! ׂ܂B萧߲Ăō\ݒ(SETUP)vNꍇA
//! usb_process_request()֐usb_standard_request.çٓĂт܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
void usb_device_task (void)
{
	if (Is_usb_vbus_high()&& usb_connected==FALSE)
	{
		usb_connected = TRUE;
		usb_start_device();
		Usb_vbus_on_action();
	}

	if(Is_usb_event(EVT_USB_RESET))
	{
		Usb_ack_event(EVT_USB_RESET);
		Usb_reset_endpoint(0);
		usb_configuration_nb=0;
	}

	// őu(ڑF)̂߂̐ڑ
	Usb_select_endpoint(EP_CONTROL);
	if (Is_usb_receive_setup())
	{
		usb_process_request();
	}
}
