 //!
//! @file usb_task.c,v
//!
//! 쌠 (c) 2006 Atmel.
//!
//! 쌠ʒmɂĂlicense.txţقǂ݂B
//!
//! @brief ̧ق͑u/νĂ̂ǂ炩܂̗͂USBƂǗ܂B
//!
//! USBƂ͗p\Ȍ݂̓`ԂɈˑĎsׂUSB
//! (usb_deviceƂ܂usb_host)Iт܂B
//!
//! (conf_usb.ḩٓɒuꂽ)USB_DEVICE_FEATUREUSB_HOST_FEATURElɏ]
//! B
//! usb_taskUSBu܂USBνēA܂2dupɑ΂Ă̗
//! x悤Ɍ`Ԑݒ肷邱Ƃł܂B
//!
//! {͑SUSB荞ݻٰ݂܂݂܂Bٰ̻݂͔񓯊USBۂ̌o
//! Ɏgp܂B
//!
//! :
//!  - usb_task͌v敔ɑAusb_device_taskusb_host͂łȂA
//!	   Wusb_taskĂ΂܂B
//!  - ̌̕`ԐݒɂĂ̂葽̏ڍׂɊւĂconf_usb.ḩق
//!	   B
//!
//! @version 1.28 at90usb128-demo-mouse-1_0_3 $Id: usb_task.c,v 1.28 2006/07/03 11:55:11 rletendu Exp $
//!
//! @todo
//! @bug
//!/

//_____ ݸٰ ____________________________________________________________

#include "config.h"
#include "conf_usb.h"
#include "usb_task.h"
#include "lib_mcu/usb/usb_drv.h"
#if ((USB_DEVICE_FEATURE == ENABLED))
#include "usb_descriptors.h"
#endif
#include "lib_mcu/power/power_drv.h"
#include "lib_mcu/wdt/wdt_drv.h"
#include "lib_mcu/pll/pll_drv.h"

#if ((USB_HOST_FEATURE == ENABLED))
  #include "modules/usb/host_chap9/usb_host_task.h"
  #if (USB_HOST_PIPE_INTERRUPT_TRANSFER == ENABLE)
	extern U8 g_sav_int_sof_enable;
  #endif
#endif

#if ((USB_DEVICE_FEATURE == ENABLED))
  #include "modules/usb/device_chap9/usb_device_task.h"
#endif

#ifndef  USE_USB_PADS_REGULATOR
  #error "USE_USB_PADS_REGULATOR" should be defined as ENABLE or DISABLE in conf_usb.h file
#endif

//_____ ϸ ________________________________________________________________

#ifndef LOG_STR_CODE
#define LOG_STR_CODE(str)
#else
U8 code log_device_disconnect[]="Device Disconnected";
U8 code log_id_change[]="Pin Id Change";
#endif

//_____ ` _______________________________________________________________

//!
//! J: U16 g_usb_event
//! usb_connectedUSBSʊ荞ݻٰ݂ŌoꂽUSBۂi[̂Ɏgp
//! ܂B̒l͈ȉϸۂɂĊǗ܂(usb_task.ḩَQ)B
//! Usb_send_event(x)
//! Usb_ack_event(x)
//! Usb_clear_all_event()
//! Is_usb_event(x)
//! Is_not_usb_event(x)
volatile U16 g_usb_event=0;

#if (USB_DEVICE_FEATURE == ENABLED)
//!
//! J: (bit) usb_connected
//! usb_connectedVBUSoꂽTRUEɐݒ肳܂B
//! Ȃusb_connectedFALSEɐݒ肳܂B
//! USB_DEVICE_FEATURE == ENABLEDŎgp܂B
//!/
extern bit usb_connected;

//!
//! J: (U8) usb_configuration_nb
//! USBuɂĎgpUSB`Ԑݒ萔i[܂B
//! ̒l0ƈႤɁA͗(ڑF)ꂽu`ԂӖ܂B
//! USB_DEVICE_FEATURE == ENABLEDŎgp܂B
//!/
extern U8 usb_configuration_nb;
#endif

#if (USB_HOST_FEATURE == ENABLED)
//!
//! I: (U8) private_sof_counter
//! νSOF荞ݻٰ݂ɂđ܂B
//! ̌vνėvł̎ԒߌoɎgp܂B
//! ͎gp҉pƂɂĕύXĂ͂Ȃ܂B
//!/
volatile U8 private_sof_counter=0;

  #if (USB_HOST_PIPE_INTERRUPT_TRANSFER == ENABLE)
extern volatile S_pipe_int it_pipe_str[MAX_EP_NB];
  #endif

#endif

#if ((USB_DEVICE_FEATURE == ENABLED)&& (USB_HOST_FEATURE == ENABLED))
//!
//! J: (U8) g_usb_mode
//! USB킪삷錻݂̓`Ԃi[邽߂2d(u/νĂ̗)
//! pŎgp܂B
//!/
U8 g_usb_mode=USB_MODE_UNDEFINED;
U8 g_old_usb_mode;
#endif

//_____ 錾 _______________________________________________________________

/**
 * @brief ̊֐USB菇܂B
 *
 *  x铮`(HOST/DEVICE/DUAL_ROLE)ɈˑāA֐͑ΉUSB
 *  `ԏ֐Ăт܂B
 *
 *  @param	Ȃ
 *
 *  @return	Ȃ
 */
void usb_task_init (void)
{
	#if (USB_HOST_FEATURE == ENABLED && USB_DEVICE_FEATURE == ENABLED)
	U8 delay;
	#endif

	#if (USE_USB_PADS_REGULATOR==ENABLE)	// ȂUSB߯ޒ͎gpȂƉ
	Usb_enable_regulator();
	#endif

// ---- 2duUSB` ---------------------------------------------
#if ((USB_DEVICE_FEATURE == ENABLED)&& (USB_HOST_FEATURE == ENABLED))
	Usb_enable_uid_pin();
	delay=PORTA;
	g_usb_mode=USB_MODE_UNDEFINED;
	if(Is_usb_id_device())
	{
		g_usb_mode=USB_MODE_DEVICE;
		usb_device_task_init();
	}
	else
	{
		g_usb_mode=USB_MODE_HOST;
		Usb_ack_id_transition();			// Kv!!! ID=0ŎnAIDݑJډ(ʰ޳n͑u`)
		Usb_enable_id_interrupt();
		Enable_interrupt();
		usb_host_task_init();
	}
	g_old_usb_mode=g_usb_mode;				// `ԕύXô߂Ɍ݂USB`Ԃi[
// -----------------------------------------------------------------------------

// ---- upUSB` ----------------------------------------------------
#elif ((USB_DEVICE_FEATURE == ENABLED)&& (USB_HOST_FEATURE == DISABLE))
	Usb_force_device_mode();
	usb_device_task_init();
// -----------------------------------------------------------------------------

// ---- ȗνĐpUSB` -------------------------------------------------
#elif ((USB_DEVICE_FEATURE == DISABLE)&& (USB_HOST_FEATURE == ENABLED))
	Usb_force_host_mode();
	usb_host_task_init();
#elif ((USB_DEVICE_FEATURE == DISABLE)&& (USB_HOST_FEATURE == DISABLE))
  #error  at least one of USB_DEVICE_FEATURE or USB_HOST_FEATURE should be enabled
#endif
// -----------------------------------------------------------------------------
}

/**
 *  @brief USBǗ̓_
 *
 *  xUSB`(HOST/DEVICE/DUAL_ROLE)ɈˑĊ֐͑ΉUSBǗ
 *  ֐Ăт܂B
 *
 *  @param	Ȃ
 *
 *  @return	Ȃ
*/
void usb_task(void)
{
// ---- 2duUSB` -------------------------------------------------
#if ((USB_DEVICE_FEATURE == ENABLED)&& (USB_HOST_FEATURE == ENABLED))
	if(Is_usb_id_device())
	{ g_usb_mode=USB_MODE_DEVICE;}
	else
	{ g_usb_mode=USB_MODE_HOST;}
	// ׂ!!! IDݗLԕύX
	// bǗ:ʰ޳ ؾ!!!
  #if ( ID_PIN_CHANGE_GENERATE_RESET == ENABLE)
	// HLIDJڂWDTؾĂ𐶐
	if((g_old_usb_mode!=g_usb_mode))
	#ifndef AVRGCC
	{Wdt_change_16ms(); while(1);   LOG_STR_CODE(log_id_change);}
	#else
	{Wdt_change_enable(); while(1); LOG_STR_CODE(log_id_change);}
	#endif

  #endif
	g_old_usb_mode=g_usb_mode;				// `ԕωô߂Ɍ݂USB`Ԃi[
	// ݂USB`ԂɈˑāAUSB(u܂ν)Jn
	switch(g_usb_mode)
	{
		case USB_MODE_DEVICE:
			usb_device_task();
			break;
		case USB_MODE_HOST:
			usb_host_task();
			break;
		case USB_MODE_UNDEFINED:			// fȂ!
		default:
			break;
	}
// -----------------------------------------------------------------------------

// ---- upUSB` ----------------------------------------------------
#elif ((USB_DEVICE_FEATURE == ENABLED)&& (USB_HOST_FEATURE == DISABLE))
	usb_device_task();
// -----------------------------------------------------------------------------

// ---- ȗνĐpUSB` -------------------------------------------------
#elif ((USB_DEVICE_FEATURE == DISABLE)&& (USB_HOST_FEATURE == ENABLED))
	usb_host_task();
// -----------------------------------------------------------------------------

//! ---- ُAꂽ`ԂȂ --------------------------------------------
#elif ((USB_DEVICE_FEATURE == DISABLE)&& (USB_HOST_FEATURE == DISABLE))
  #error  at least one of USB_DEVICE_FEATURE or USB_HOST_FEATURE should be enabled
  #error  otherwise the usb task has nothing to do ...
#endif
// -----------------------------------------------------------------------------
}

//! @brief USB荞ݻٰ
//!
//! ̊֐USB荞݂N閈ɌĂ΂܂B
//! ȉUSBuۂS܂B
//! - VBUSON/OFF
//! - ڰъJn
//! - x~(Suspend)
//! - Nオ
//! - ĊJ(Resume)
//! - ؾ
//!
//! ȉUSBνĎۂS܂B
//! - uڑ
//! - uؒf
//! - ڰъJn
//! - IDݕω
//! - SOF(܂͒ᑬ(Low-Speed)ł̐ێ)o
//! - USBł̋Nオ茟o
//!
//! eۂɂāAgp҂͒g`邱ƂɂĊJn邱
//! Ƃł܂(ۂɊǉɂconf_usb.ḩق)B
//!
//! :ꂽ荞ݎۂ܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
#ifdef AVRGCC
ISR(USB_GEN_vect)
#else
#pragma vector = USB_GENERAL_vect
__interrupt void usb_general_interrupt()
#endif
{
	#if (USB_HOST_PIPE_INTERRUPT_TRANSFER == ENABLE)
	U8 i;
	U8 save_pipe_nb;
	#endif
// ---------- uۊǗ -----------------------------------------------------
#if (USB_DEVICE_FEATURE == ENABLED)
	// - VBUSԌo
	if (Is_usb_vbus_transition() && Is_usb_vbus_interrupt_enabled())
	{
		Usb_ack_vbus_transition();
		if (Is_usb_vbus_high())
		{
			usb_connected = TRUE;
			Usb_vbus_on_action();
			Usb_send_event(EVT_USB_POWERED);
			Usb_enable_reset_interrupt();
			usb_start_device();
			Usb_attach();
		}
		else
		{
			Usb_vbus_off_action();
			usb_connected = FALSE;
			usb_configuration_nb = 0;
			Usb_send_event(EVT_USB_UNPOWERED);
		}
	}
	// - uڰъJn󂯎
	if (Is_usb_sof() && Is_sof_interrupt_enabled())
	{
		Usb_ack_sof();
		Usb_sof_action();
	}
	// - ux~(Suspend)(ȏUSBoȂ)
	if (Is_usb_suspend() && Is_suspend_interrupt_enabled())
	{
		Usb_ack_suspend();
		Usb_enable_wake_up_interrupt();
		Usb_ack_wake_up();					// ̎ۂo邽߂ɋNオ
		Usb_freeze_clock();
		Usb_send_event(EVT_USB_SUSPEND);
		Usb_suspend_action();
	}
	// - Nオ莖(USBo):ĊJ(Resume)Ɏgp
	if (Is_usb_wake_up() && Is_swake_up_interrupt_enabled())
	{
		Usb_unfreeze_clock();
		Usb_ack_wake_up();
		Usb_disable_wake_up_interrupt();
		Usb_wake_up_action();
		Usb_send_event(EVT_USB_WAKE_UP);
	}
	// - ĊJ(Resume)Ԃ޽o
	if (Is_usb_resume() && Is_resume_interrupt_enabled())
	{
		Usb_disable_wake_up_interrupt();
		Usb_ack_resume();
		Usb_disable_resume_interrupt();
		Usb_resume_action();
		Usb_send_event(EVT_USB_RESUME);
	}
	// - USB޽ ؾČo
	if (Is_usb_reset()&& Is_reset_interrupt_enabled())
	{
		Usb_ack_reset();
		usb_init_device();
		Usb_reset_action();
		Usb_send_event(EVT_USB_RESET);
	}
#endif // u@\I

// ---------- νĎۊǗ ------------------------------------------------------
#if (USB_HOST_FEATURE == ENABLED && USB_DEVICE_FEATURE == ENABLED)
	// - IDݕωo
	if(Is_usb_id_transition()&&Is_usb_id_interrupt_enabled())
	{
		if(Is_usb_id_device())
		{ g_usb_mode=USB_MODE_DEVICE;}
		else
		{ g_usb_mode=USB_MODE_HOST;}
		Usb_ack_id_transition();
		if( g_usb_mode != g_old_usb_mode)	// {IȒ΍
		{
			if(Is_usb_id_device())			// u`ԂɂȂB
			{
				Usb_send_event(EVT_USB_DEVICE_FUNCTION);
			}
			else							// νē`ԂɂȂB
			{
				Usb_send_event(EVT_USB_HOST_FUNCTION);
			}
			Usb_id_transition_action();
			LOG_STR_CODE(log_id_change);
		  #if ( ID_PIN_CHANGE_GENERATE_RESET == ENABLE)
			// LIDJڂWDTؾĂ𐶐
			#ifndef  AVRGCC
			Wdt_change_16ms(); while(1);
			#else
			Wdt_change_enable(); while(1);
			#endif
		  #endif
		}
	}
#endif
#if (USB_HOST_FEATURE == ENABLED)
	// - uؒf
	if(Is_device_disconnection() && Is_host_device_disconnection_interrupt_enabled())
	{
		host_disable_all_pipe();
		Host_ack_device_disconnection();
		device_state=DEVICE_DISCONNECTED;
		Usb_send_event(EVT_HOST_DISCONNECTION);
		LOG_STR_CODE(log_device_disconnect);
		Host_device_disconnection_action();
	}
	// - uڑ
	if(Is_device_connection() && Is_host_device_connection_interrupt_enabled())
	{
		Host_ack_device_connection();
		host_disable_all_pipe();
		Host_device_connection_action();
	}
	// - νĂڰъJn𑗏o܂B
	if (Is_host_sof() && Is_host_sof_interrupt_enabled())
	{
		Host_ack_sof();
		Usb_send_event(EVT_HOST_SOF);
		private_sof_counter++;

		// ē`Ԃł̊荞ݓ]pxԒߊǗ
		#if ((USB_HOST_PIPE_INTERRUPT_TRANSFER==ENABLE) && (TIMEOUT_DELAY_ENABLE==ENABLE))
		if (private_sof_counter>=250)		// 1/4bv
		{
			private_sof_counter=0;
			for(i=0;i<MAX_EP_NB;i++)
			{
				if(it_pipe_str[i].enable==ENABLE)
				{
					save_pipe_nb=Host_get_selected_pipe();
					Host_select_pipe(i);
					if((++it_pipe_str[i].timeout>TIMEOUT_DELAY) && (Host_get_pipe_type()!=TYPE_INTERRUPT))
					{
						it_pipe_str[i].enable=DISABLE;
						it_pipe_str[i].status=PIPE_DELAY_TIMEOUT;
						Host_stop_pipe_interrupt(i);
						if (is_any_interrupt_pipe_active()==FALSE)	// ȏ]Ȃꍇ
						{
							if (g_sav_int_sof_enable==FALSE)
							{
								Host_disable_sof_interrupt();
							}
						}
						it_pipe_str[i].handle(PIPE_DELAY_TIMEOUT,it_pipe_str[i].nb_byte_processed);
					}
					Host_select_pipe(save_pipe_nb);
				}
			}
		}
		#endif // (USB_HOST_PIPE_INTERRUPT_TRANSFER==ENABLE) && (TIMEOUT_DELAY_ENABLE==ENABLE))
		Host_sof_action();
	}
	// - νċNオ󂯎
	if (Is_host_hwup() && Is_host_hwup_interrupt_enabled())
	{
		Host_disable_hwup_interrupt();  // Nオ芄荞݂͍νĂNオ̂ŋ֎~ׂłB
		// x:USBۯ(łȂ)ɂHWUP͉邱Ƃł܂!
		Pll_start_auto();               // USB̂߂̍ŏPLLĎn
		Wait_pll_ready();               // mPLLŒ艻𓾂
		Usb_unfreeze_clock();           // USB̪ł̸ۯ
		Host_ack_hwup();                // HWUP荞ݗv׸މ
		Usb_send_event(EVT_HOST_HWUP); // ĳۑo
		Host_hwup_action();             // Ǝ蓖
	}
#endif // νċ@\I
}

extern void suspend_action (void)
{
	Enable_interrupt();
	Enter_power_down_mode();
}

extern void host_suspend_action (void)
{
//	Enter_power_down_mode();  // Ⴆ΁A`
}
