//! @file conf_usb.h,v
//!
//! 쌠 (c) 2006 Atmel.
//!
//! 쌠ʒmɂĂlicense.txţقǂłB
//!
//! ̧قUSB̉\ȊO`Ԑݒ܂݂܂B
//!
//! @version 1.3 at90usb128-demo-mouse-1_0_3 $Id: conf_usb.h,v 1.3 2006/07/27 07:28:50 rletendu Exp $
//!
//! @todo
//! @bug
#ifndef _CONF_USB_H_
#define _CONF_USB_H_

//! @defgroup usb_general_conf USBp`Ԑݒ
//!
//! @{

	// _________________ USB`Ԑݒ ____________________________
	//
	//! @defgroup USB_op_mode USB`Ԑݒ
	//! pɂĎx鑕u܂νĂUSB`Ԃ邽߂̒`
	//! @{

		//! @brief ν ĳ ײ؎xɂɂENABLED
		//!
		//! \ȒlENABLED܂DISABLED
		#define USB_HOST_FEATURE		DISABLED

		//! @brief uĳ ײ؎xɂɂENABLED
		//!
		//! \ȒlENABLED܂DISABLED
		#define USB_DEVICE_FEATURE	ENABLED

	//! @}

	// _________________ USBd`Ԑݒ _______________________
	//
	//! @defgroup USB_reg_mode USBd`Ԑݒ
	//! @{

	//! @brief USB߯ޗp
	//!
	//! pd3.5VႢɁAd͂œK邽߂ɁAUSB߯
	//! ֎~邱Ƃł܂B
#ifndef USE_USB_PADS_REGULATOR
	#define USE_USB_PADS_REGULATOR	ENABLE	// \ȒlENABLE܂DISABLE
#endif
	//! @}

	// _________________ νē`Ԑݒ ____________________________
	//
	//! @defgroup USB_host_mode_cfg USBνē`Ԑݒ
	//!
	//! @{

	#define HID_CLASS				0x03
	#define MS_CLASS				0x08

	//!   @brief xVID/PIDꗗ\
	//!
	//!	̕\͏ȗνĉpɂĎxVID/PID܂݂܂B
	//!	VID_PID_TABLE``:
	//!
	//!	#define VID_PID_TABLE	{VID1, number_of_pid_for_this_VID1, PID11_value,..., PID1X_Value \n
	//!							...\n
	//!							,VIDz, number_of_pid_for_this_VIDz, PIDz1_value,..., PIDzX_Value}
	#define VID_PID_TABLE			{0x03EB, 2, 0x201C, 0x2014 \
									,0x0123, 3, 0x2000, 0x2100, 0x1258}

	//!   @brief xCLASS/SUBCLASS_PROTOCOLꗗ\
	//!
	//!	̕\͏ȗνĉpɂĎx׽/׽/K܂݂܂B
	//!	̕\`͊ȒPVID/PIDꗗ\ɑāA׽/׽/KŜɑ΂
	//!	gpux܂B
	//!
	//!	׽/׽/K``: \n
	//!	#define CLASS_SUBCLASS_PROTOCOL	{CLASS1, SUB_CLASS1,PROTOCOL1, \n
	//!									...\n
	//!									CLASSz, SUB_CLASSz,PROTOCOLz}
	#define CLASS_SUBCLASS_PROTOCOL	{0x0A, 0x00, 0x00, \
									 0x00, 0x00, 0x00,\
									 0xFF,0x00,0x00}

	#define SIZEOF_DATA_STAGE				250		//!< Lqq̗\񂳂ꂽRAMɏՕ̑傫
	#define DEVICE_ADDRESS					0x05	//!< ڑꂽuɊ蓖Ăڽ
	//! νĐ͌VID/PIDꗗɐ܂B
	//! ƁAuPID/VIDxꗗɑȂꍇAνĐײ؂
	//! [`ԐݒɂȂ炸AُԂɂȂ܂B
	#define HOST_STRICT_VID_PID_TABLE		DISABLE
	#define HOST_AUTO_CFG_ENDPOINT			ENABLE	//!< 󂯎uLqqɏ]ν ߲߂̌`Ԑݒ݂܂B
	#define HOST_CONTINUOUS_SOF_INTERRUPT	DISABLE	//!< νĂڰъJn荞݂ɋ
	#define HOST_ERROR_RESTART				ENABLE	//!< νĂُ̈ԌoAڑԂɍs
	#define ID_PIN_CHANGE_GENERATE_RESET	DISABLE	//!< IDݕωWDTؾĂ
	#define NAK_TIMEOUT_DELAY				1		//!< Ԓߒl̑O1/4s(250ms)NAK޼
  #if (HOST_AUTO_CFG_ENDPOINT==FALSE)
	//! ߲Ă̎`ԐݒȂ̏ꍇAɎgpҊ֐zu
	#define									User_configure_endpoint()
  #endif

	//! @defgroup host_cst_actions USBνēƎ
	//!
	//! @{
	// eUSBνĎۂƒg銈ɏĂB
	// @\זȂԂōňԂɂȂȂ悤ɒӂĂB
	#define Usb_id_transition_action()
	#define Host_device_disconnection_action()
	#define Host_device_connection_action()
	#define Host_sof_action()
	#define Host_suspend_action()			host_suspend_action();
	#define Host_hwup_action()
	#define Host_device_not_supported_action()
	#define Host_device_supported_action()
	#define Host_device_error_action()
	//! @}

extern void host_suspend_action(void);
	//! @}

// _________________ u`Ԑݒ __________________________

	//! @defgroup USB_device_mode_cfg USBu`
	//!
	//! @{

#define NB_ENDPOINTS			2			//! ߲Ă܂މpł̴߲Đ
#define EP_MOUSE_IN				1			//! ϳ荞IN߲Đ

//! USBux`(S(Full-speed)ڑ𓾂邽߂ɊDISABLE)
#define USB_LOW_SPEED_DEVICE	DISABLE

#define Usb_unicode(a)			((U16)(a))

	//! @defgroup device_cst_actions USBuƎ
	//!
	//! @{
	// eUSBۂƒg銈ɏĂB
	// @\זȂԂōňԂɂȂȂ悤ɒӂĂB
#define Usb_sof_action()		sof_action();
#define Usb_wake_up_action()
#define Usb_resume_action()
#define Usb_suspend_action()	suspend_action();
#define Usb_reset_action()
#define Usb_vbus_on_action()
#define Usb_vbus_off_action()	vbus_off_action();
#define Usb_set_configuration_action()
	//! @}

extern void sof_action(void);
extern void suspend_action(void);
extern void vbus_off_action(void);
	//! @}

//! @}

#endif // _CONF_USB_H_
